
#include "AppEvent.Ch"
#include "DcBitMap.Ch"
#include "DcCursor.Ch"
#include "DcDialog.Ch"
#include "DcGra.Ch"
#include "DcIcon.Ch"
#include "Inkey.Ch"
#include "Set.Ch"
#include "Xbp.Ch"

#define VK_NUMLOCK        0x90
#define VK_SCROLL         0x91
#define VK_CAPITAL        0x14
#define APPKEY_PRESSED    2

PROCEDURE Mvp605

  LOCAL GetList := {}, GetOptions, oGroup1, oGroup2, lStatus, oStatBar, oMsgStatic, oInsStatic, oNumStatic, oCapsStatic, oMsgBox

  PRIVATE cCode, cDesc, lClosed

  DC_Gui(.t.)
  DC_SetKeyActive(.t.)
  DC_GetPopupCaption({ '12.Arial Bold', BITMAP_SCAN_M, 0 })
  DC_GetPopupAutoHide(.t.)

  PrgSecurity(@aSecurity, @aMvMenu06, "MVP605", GetList)

  SELECT CodeMst
  SET ORDER TO 1

  nGroup  := 1
  lStatus := .f.
  lNewRec := .f.
  cRecId  := "M5"
  cCode   := Space(4)
  cDesc   := Space(45)
  lClosed := .f.


  @  1.00, 0.00 DCGROUP oGroup1        CAPTION ' Collections Agency Code '          SIZE 75.00, 4.00                                                      COLOR GRA_CLR_BLUE

  @  1.25, 2.00 DCSAY 'Collections Code'                                            SIZE  0                                 PARENT oGroup1                COLOR GRA_CLR_BLUE
  @  1.00,20.00 DCGET cCode            Picture '!!!!'                                                                       PARENT oGroup1                COLOR GRA_CLR_BLACK ;
					 TABSTOP ;
				    NOCONFIRM ;
                GETID "Get_cCode" ;
                WHEN {|| nGroup == 1 } ;
                TABGROUP XBP_BEGIN_GROUP ;
                VALID {|| ValidateCode(cCode, GetList) } ;
                POPUP {|c| c := GuiCodeScan(c, GetList) } ;
                MESSAGE 'Enter The Collections Code To Be Maintained.' INTO oMsgBox

  @  2.50, 2.00 DCSAY 'Collections Description '                                    SIZE  0                                 PARENT oGroup1                COLOR GRA_CLR_BLUE
  @  2.25,20.00 DCGET cDesc            Picture '!XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX'                              PARENT oGroup1                COLOR GRA_CLR_BLACK ;
				    PROPER ;
 				    GETOBJECT oDesc ;
                GETID "Get_cDesc" ;
                WHEN {|| !Empty(cCode) } ;
                TABGROUP XBP_WITHIN_GROUP ;
                MESSAGE "Enter Collections Description."  INTO oMsgBox

  @  1.00,34.00 DCCHECKBOX lClosed     PROMPT '  Closed'                                                                    PARENT oGroup1                COLOR GRA_CLR_BLUE ;
                ID "Get_lClosed" ;
                TABGROUP XBP_END_GROUP ;
                WHEN {|| !Empty(cCode) } ;
                CURSOR { Nil, POINTER_PEN_1, Nil } ;
                MESSAGE 'Flag The Collections Code As Citation Status Open or Closed.' INTO oMsgBox


  @  5.50, 1.00 DCPUSHBUTTON           CAPTION {|| IIF(lNewRec,'Add','Update') }    SIZE  9.00, 1.20 ;
                WHEN {|| !Empty(cCode) .AND. aSecurity[2] } ;
                ACTION {|| CodeAction(IIF(lNewRec,1,2),GetList) }

  @  5.50,12.00 DCPUSHBUTTON           CAPTION 'Delete'                             SIZE  9.00, 1.20 ;
                ACTION {|| CodeAction(3,GetList) } ;
                WHEN {|| !lNewRec .AND. !Empty(cCode) .AND. aSecurity[3] }

  @  5.50,23.00 DCPUSHBUTTON           CAPTION 'Cancel'                             SIZE  9.00, 1.20 ;
                CARGO 'CANCEL' ;
                WHEN {|| !Empty(cCode) } ;
                ACTION {|| CodeAction(0,GetList) }

  @  5.50,34.00 DCPUSHBUTTON           CAPTION 'Exit'                               SIZE  9.00, 1.20 ;
                CARGO 'CANCEL' ;
                ACTION {|| DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

  @  5.50,66.00 DCPUSHBUTTON           CAPTION 'Report'                             SIZE  9.00, 1.20 ;
                ACTION {|| Mvp700("Collection",cRecId) } ;
                WHEN {|| Empty(cCode) .AND. aSecurity[4] }


  DCSTATUSBAR oStatBar HEIGHT 25 ALIGN DCGUI_ALIGN_BOTTOM SPACING 0

  @  3.00, 0.00 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX ;
			       SIZE 300,20 ;
			       PARENT oStatBar PIXEL OBJECT oMsgStatic

  @  2.00, 2.00 DCMESSAGEBOX TYPE XBPSTATIC_TYPE_TEXT ;
                SIZE 300,20 ;
                COLOR GRA_CLR_BLUE, GRA_CLR_BACKGROUND ;
                OBJECT oMsgBox PARENT oMsgStatic PIXEL

  @  3.00, 0.00 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX ;
			       SIZE 30,20 PARENT oStatBar PIXEL OBJECT oCapsStatic

  @  1.00, 1.00 DCSAY '' PARENT oCapsStatic ID 'CAPSLOCK' ;
			       SAYSIZE 28,18 SAYCENTER PIXEL

  @  3.00, 0.00 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX ;
			       SIZE 30,20 PARENT oStatBar PIXEL OBJECT oNumStatic

  @  1.00, 1.00 DCSAY '' PARENT oNumStatic ID 'NUMLOCK' ;
			       SAYSIZE 28,18 SAYCENTER PIXEL

  @  3.00, 0.00 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX ;
			       SIZE 30,20 PARENT oStatBar PIXEL OBJECT oInsStatic

  @  1.00, 1.00 DCSAY '' PARENT oInsStatic ID 'INSERT' ;
			       SAYSIZE 28,18 SAYCENTER PIXEL

  DCHOTKEY K_INS ACTION {|| ReadInsert(!ReadInsert()) }

  DCGETOPTIONS ;
    CASCADE ;
    SOURCEFILE __FILEPATH__


  DCREAD GUI ;
         FIT ;
			MODAL ;
         OPTIONS GetOptions ;
         TITLE ' Maintain Collection Agency Code ' ;
			EVAL {|o| SetTimerEvent(100,{|| _UpdateStats(GetList)}) }

	SetTimerEvent(0)

RETURN

*---

STATIC FUNCTION CodeAction( nAction, GetList )

  IF nAction == 1 .OR. nAction == 2              // add record

	 SET ORDER TO 1
	 SEEK cRecId + cCode
	 IF Eof()
      APND()
    ENDIF
    IF DC_RecLock(5)                                    // Update Record Text
      REPLACE CmRecid   WITH cRecId
      REPLACE CmCode    WITH cCode
      REPLACE CmDesc    WITH cDesc
      REPLACE CmSumm    WITH lClosed
      UNLOCK
    ENDIF

  ELSEIF nAction == 3                             // delete record

	 SET ORDER TO 1
	 SEEK cRecId + cCode
    IF !Eof()
      IF DC_RecLock(5)
        DELETE
        UNLOCK
      ENDIF
    ENDIF

  ENDIF

  nGroup  := 1
  lNewRec := .f.
  cCode   := Space(4)
  cDesc   := Space(45)
  lClosed := .f.

  DC_ReadGuiEvent(DCGUI_MOVE_TOP, GetList)
  DC_GetRefresh(GetList)

RETURN Nil

*---

STATIC FUNCTION ValidateCode( cCode, GetList )

  nGroup    := 2
  SET ORDER TO 1
  SEEK cRecId + cCode

  IF Eof()
    lNewRec := .t.
  ELSE
    lNewRec := .f.
    cDesc   := CodeMst->CmDesc
    lClosed := CodeMst->CmSumm
  ENDIF

  DC_GetRefresh(GetList)

RETURN .t.

*---

STATIC FUNCTION GuiCodeScan( c, aGetList)

  LOCAL GetList := {}, GetOptions, oBrowse, aPres, aBrowPres, aSort, aSort2[8], cSeek := Space(25)

  SET ORDER TO 2
  CodeMst->(DC_SetScope(0,cRecId))
  CodeMst->(DC_SetScope(1,cRecId))
  CodeMst->(DC_DbGoTop())

  SET ORDER TO 1
  CodeMst->(DC_SetScope(0,cRecId))
  CodeMst->(DC_SetScope(1,cRecId))
  CodeMst->(DC_DbGoTop())

  aPres     := DC_BrowPres()
  aSort     := DC_BrowseSort()

  aBrowPres := {{ XBP_PP_COL_HA_FGCLR, GRA_CLR_BLACK },             /* Header FG Color  */  ;
                { XBP_PP_COL_HA_BGCLR, GRA_CLR_PALEGRAY },          /* Header BG Color  */  ;
                { XBP_PP_COL_DA_ROWSEPARATOR, XBPCOL_SEP_DOTTED },  /* Row Sep          */  ;
                { XBP_PP_COL_DA_COLSEPARATOR, XBPCOL_SEP_DOTTED },  /* Col Sep          */  ;
                { XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK },             /* Row FG Color     */  ;
                { XBP_PP_COL_DA_BGCLR, GRA_CLR_WHITE },             /* Row BG Color     */  ;
                { XBP_PP_COL_DA_ROWHEIGHT, 11 },                    /* Row Height       */  ;
                { XBP_PP_COL_DA_CELLHEIGHT, 11 },                   /* Cell Height      */  ;
                { XBP_PP_COL_HA_HEIGHT, 12 },                       /* Header Height    */  ;
                { XBP_PP_COL_DA_HILITE_FGCLR, GRA_CLR_BLUE },       /* Cursor FG Color  */  ;
                { XBP_PP_COL_DA_HILITE_BGCLR, GRA_CLR_PALEGRAY},    /* Cursor BG Color  */  ;
                { XBP_PP_HILITE_FGCLR, GRA_CLR_WHITE },             /* Hilite FG color  */  ;
                { XBP_PP_HILITE_BGCLR, GRA_CLR_BLUE },              /* Hilite BG color  */  ;
                { XBP_PP_COL_FA_FGCLR, GRA_CLR_WHITE },             /* Footer FG Color  */  ;
                { XBP_PP_COL_FA_BGCLR, GRA_CLR_PALEGRAY },          /* Footer BG Color  */  ;
                { XBP_PP_COL_DA_COMPOUNDNAME,'9.Arial'},            /* Font             */  ;
                { XBP_PP_COL_HA_COMPOUNDNAME,'9.Helv'},             /* Font             */  ;
                { XBP_PP_COL_FA_HEIGHT, 12 },                       /* Footer Height    */  ;
                { XBP_PP_COL_HA_ALIGNMENT,XBPALIGN_HCENTER}         /* Header Alignment */  ;
               }

  aSort2[1] := GRA_CLR_RED              // Sort Selected Color (Foreground)                     // PC CAW 01-13-05
  aSort2[2] := GRA_CLR_PALEGRAY         // Sort Selected Color (Background)
  aSort2[3] := GRA_CLR_BLACK            // Sort Unselectable Color (Foreground)
  aSort2[4] := GRA_CLR_PALEGRAY         // Sort Unselectable Color (Background)
//  aSort2[5] := Nil                    // No Longer Utilized
//  aSort2[6] := Nil                    // No Longer Utilized
  aSort2[7] := GRA_CLR_BLACK            // Sort Unselected Color (Foreground) - Able to select
  aSort2[8] := GRA_CLR_PALEGRAY         // Sort Unselected Color (Background) - Able to select

  DC_BrowPres(aBrowPres)                                           // save browse presentation factors

  DC_BrowseSort(aSort2)


  @  1.00, 1.00 DCGET cSeek      Picture '@!'                                                      KEYBLOCK {|a,b,o| _Mvp605( a, b, o, oBrowse, @cSeek ) } ;
                GETID "Get_cSeek"

  @  2.50, 1.00 DCBROWSE oBrowse ALIAS 'CodeMst'                                                   SIZE 50,20 ;
  			       FIT ;
  			       SCOPE ;
			       NOHSCROLL ;
			       HEADLINES 2 ;
  			       NOSOFTTRACK ;
                PRESENTATION DC_BrowPres() ;
			       CURSORMODE XBPBRW_CURSOR_ROW ;
                SORTUPBITMAP BITMAP_RD_UP_RED ;
                SORTDOWNBITMAP BITMAP_RD_DOWN_RED ;
                SORTSCOLOR GRA_CLR_RED, GRA_CLR_PALEGRAY ;
                SORTUCOLOR GRA_CLR_BLACK, GRA_CLR_PALEGRAY ;
  			       ITEMSELECTED { || DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

  DCBROWSECOL   DATA {|| CodeMst->CmCode}                      HEADER 'Disposition;Code'           WIDTH  8  PARENT oBrowse ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'}} ;
                SORT {|| OrdSetFocus('CODEMX01')} LEFTBUTTON ;
                _DEFAULT OrdSetFocus() == 'CODEMX01'

  DCBROWSECOL   DATA {|| Trim(CodeMst->CmDesc)}                HEADER ';Disposition Description'   WIDTH 25  PARENT oBrowse ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'}} ;
                SORT {|| OrdSetFocus('CODEMX02')} LEFTBUTTON

  DCBROWSECOL   DATA  {|| IIF(CodeMst->CmSumm,"Yes", "No") }   HEADER 'Closed;Disposition'         WIDTH  6  PARENT oBrowse

  DCREAD GUI TO lStatus ;
         FIT ;
         MODAL ;
         ADDBUTTONS ;
	      TITLE 'Select Desired Collection Agency Code' ;
         EVAL { || SetAppFocus(DC_GetObject(GetList,"Get_cSeek")) }

  IF lStatus

    nGroup  := 2
    lNewRec := .f.
	 cCode   := CodeMst->CmCode
    cDesc   := CodeMst->CmDesc
    lClosed := CodeMst->CmSumm

    DC_GetRefresh(aGetList)
    SetAppFocus(DC_GetObject(aGetList,"Get_cDesc"))

  ELSE

    nGroup  := 1
    lNewRec := .t.
    cCode   := Space(4)
    cDesc   := Space(45)
    lClosed := .f.

    DC_GetRefresh(aGetList)
    SetAppFocus(DC_GetObject(aGetList,"Get_cCode"))

  ENDIF

  SET ORDER TO 1
  DC_ClrScope()
  SET ORDER TO 2
  DC_ClrScope()

  DC_BrowPres(aPres)                                           // save browse presentation factors
  DC_BrowseSort(aSort)

RETURN cCode

*---

STATIC FUNCTION _Mvp605( a, b, o, oBrowse, cSeek )

  LOCAL lClearBuffer := .t., lSoftSeek := Set(_SET_SOFTSEEK, .t.)

  IF     a == xbeK_UP
    oBrowse:up()
  ELSEIF a == xbeK_DOWN
    oBrowse:down()
  ELSEIF a == xbeK_PGUP
    oBrowse:pageUp()
  ELSEIF a == xbeK_PGDN
    oBrowse:pageDown()
  ELSEIF a == xbeK_END
    oBrowse:goBottom()
  ELSEIF a == xbeK_HOME
    oBrowse:goTop()
  ELSE
    SEEK cRecId + AllTrim(o:EditBuffer())
    lClearBuffer := .f.
  ENDIF

  oBrowse:refreshAll()

  IF lClearBuffer
    cSeek := Space(25)
    o:Get:home()
    o:setData()
  ENDIF

  Set(_SET_SOFTSEEK,lSoftSeek)

RETURN Nil

*---

STATIC FUNCTION _UpdateStats( GetList )

  LOCAL oCapsLock := DC_GetObject(GetList,'CAPSLOCK')
  LOCAL oNumLock  := DC_GetObject(GetList,'NUMLOCK')
  LOCAL oInsert   := DC_GetObject(GetList,'INSERT')
  LOCAL lCaps     := AppKeyState( VK_CAPITAL,.t. )
  LOCAL lNum      := AppKeyState( VK_NUMLOCK,.t. )

  IF lNum == APPKEY_PRESSED
    oNumLock:SetCaption( "Num" )
  ELSE
    oNumLock:SetCaption( "" )
  ENDIF

  IF lCaps == APPKEY_PRESSED
    oCapsLock:SetCaption( "Caps" )
  ELSE
    oCapsLock:SetCaption( "" )
  ENDIF

  IF ReadInsert()
    oInsert:SetCaption( "Ins" )
  ELSE
    oInsert:SetCaption( "Ovr" )
  ENDIF

RETURN Nil
